* Demo program for GLGDW 2006 by Barbara Peisch (c) 2005
*   You may include or modify any of the code or forms included in this demo as you see fit.
*   You may not claim it as your own, nor try to enforce a copyright.
*   All samples in this demo are provided "as is" with no implied guarantees nor waranties.

* NOTES:
*  This demo assumes that you have a copy of XFRX
*  in order to run reports using that products. This is acommercial third party
*  products for which you must have a legal copy on your machine in order to run.
*  Eval version is available:
* XFRX: http://www.eqeus.com/xfrxdemo.php
*  You may need to change the SET PATH statement, below, to the directory where you
*  have installed this product.

public oApp

local OldTalk, OldStatus, OldCentury, OldDelete, OldMultiLocks, OldBell
local OldSafety, OldStatusbar

OldTalk = set('Talk')
set talk off
OldStatus = set('Status')
OldCentury = set('Century')
OldDelete = set('Deleted')
OldMultilocks = set('Multilocks')
OldBell = set('Bell')
OldSafety = set('Safety')
OldStatusbar = set('Status bar')
OldNotify = set('Notify')
on shutdown quit
close databases all		&& Closes an DBCs
close databases			&& Closes free tables

_screen.windowstate = 2
clear
_screen.visible = .T.
_screen.Caption = "Report Class Demo"

close databases all
hide window all           && will hide the project manager if it's open
if wexist('Standard')
   hide window Standard      && hide standard toolbar if it's open
endif
if wexist('Form Controls')   && hide form controls toolbar if it's open
	hide window Form
endif

ON ERROR MESSAGEBOX(MESSAGE())
oApp = createobject('DemoApp')

* Must use absolute pathing for cases when they send output to a PDF in a different
* directory.
* Acrobat is changing the default directory!
oApp.AppDir = SYS(5)+CURDIR()
set path to ("\XFRX;\XFRX\XFRXLIB;"+HOME()+"FFC")
SET CLASSLIB TO XFRXLIB,_Reportlistener, Reports
SET PROCEDURE TO OutputClass, DataClass, Listeners

IF NOT DIRECTORY('REPORTS')
	MD REPORTS
ENDIF 

do form PrtOut

set status &OldStatus
set talk &OldTalk
set century &OldCentury
set deleted &OldDelete
set multilocks &OldMultilocks
set bell &OldBell
set safety &OldSafety
set sysmenu to default
set status bar &OldStatusbar
set notify &OldNotify

return
*------------------------------------------------------------------------------
FUNCTION PctBar
*    Returns a bar for printing/display of the appropriate length according to Pct passed
*    Lngth is length of bar in characters at 100%.  If not passed, a default of 100 is used

lparameter Pct, Lngth, Char

local BarGrph, BSize

if empty(Lngth)
	Lngth = 100
endif

if empty(Char)
	Char = chr(110)
endif

BarGrph = ''

if not empty(Pct)
	BSize = round((Pct/100)*Lngth,0)
	
	BarGrph = replicate(Char,round(BSize, 0))
endif

return BarGrph

ENDFUNC
*------------------------------------------------------------------------------
* Application object
define class DemoApp as relation

	AppDir = ''
	oRptForm = .Null.  && For the Minds Eye Report Engine (must stay in scope after calling class)

enddefine
*------------------------------------------------------------------------------
**********************************************************************
